function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (getDisplayWindow().storeSuspendData && getDisplayWindow().storeSuspendData.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'introduction_to_health_care_and_life_sciences', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:803515,v:'normalState'},{id:803525,v:'normalState'},{id:803535,v:'normalState'},{id:803550,v:'normalState'},{id:803563,v:'normalState'},{id:803571,v:'normalState'},{id:803583,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720734,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:804207,v:'normalState'},{id:804216,v:'normalState'},{id:804225,v:'normalState'},{id:804234,v:'normalState'},{id:820122,v:'normalState'},{id:804247,v:'normalState'},{id:804259,v:'normalState'},{id:804271,v:'normalState'},{id:804283,v:'normalState'},{id:820114,v:'normalState'},{id:804451,v:'normalState'},{id:804488,v:'normalState'},{id:805621,v:'normalState'},{id:805657,v:'normalState'},{id:805669,v:'normalState'},{id:805681,v:'normalState'},{id:805693,v:'normalState'},{id:805705,v:'normalState'},{id:805717,v:'normalState'},{id:828227,v:'normalState'},{id:805734,v:'normalState'},{id:805757,v:'normalState'},{id:805776,v:'normalState'},{id:805795,v:'normalState'},{id:805814,v:'normalState'},{id:805833,v:'normalState'},{id:805852,v:'normalState'},{id:828219,v:'normalState'},{id:805871,v:'normalState'},{id:805879,v:'normalState'},{id:805888,v:'normalState'},{id:836499,v:'normalState'},{id:836511,v:'normalState'},{id:836523,v:'normalState'},{id:836535,v:'normalState'},{id:836547,v:'normalState'},{id:836559,v:'normalState'},{id:836571,v:'normalState'},{id:836588,v:'normalState'},{id:836610,v:'normalState'},{id:836628,v:'normalState'},{id:836646,v:'normalState'},{id:836664,v:'normalState'},{id:836682,v:'normalState'},{id:840007,v:'normalState'},{id:836718,v:'normalState'},{id:836736,v:'normalState'},{id:836744,v:'normalState'},{id:836753,v:'normalState'},{id:841731,v:'normalState'},{id:841743,v:'normalState'},{id:841755,v:'normalState'},{id:841767,v:'normalState'},{id:841779,v:'normalState'},{id:841791,v:'normalState'},{id:841803,v:'normalState'},{id:841820,v:'normalState'},{id:841842,v:'normalState'},{id:841860,v:'normalState'},{id:841878,v:'normalState'},{id:841896,v:'normalState'},{id:841914,v:'normalState'},{id:841932,v:'normalState'},{id:841950,v:'normalState'},{id:841968,v:'normalState'},{id:841976,v:'normalState'},{id:841985,v:'normalState'},{id:845259,v:'normalState'},{id:845271,v:'normalState'},{id:845283,v:'normalState'},{id:845295,v:'normalState'},{id:845307,v:'normalState'},{id:845319,v:'normalState'},{id:845331,v:'normalState'},{id:845348,v:'normalState'},{id:845370,v:'normalState'},{id:845388,v:'normalState'},{id:845406,v:'normalState'},{id:845424,v:'normalState'},{id:845442,v:'normalState'},{id:845460,v:'normalState'},{id:845478,v:'normalState'},{id:845496,v:'normalState'},{id:845504,v:'normalState'},{id:845513,v:'normalState'},{id:850099,v:'normalState'},{id:850111,v:'normalState'},{id:850123,v:'normalState'},{id:850135,v:'normalState'},{id:850147,v:'normalState'},{id:850159,v:'normalState'},{id:850171,v:'normalState'},{id:850188,v:'normalState'},{id:850210,v:'normalState'},{id:850228,v:'normalState'},{id:850246,v:'normalState'},{id:850264,v:'normalState'},{id:850282,v:'normalState'},{id:850300,v:'normalState'},{id:850318,v:'normalState'},{id:850337,v:'normalState'},{id:850345,v:'normalState'},{id:850354,v:'normalState'},{id:854706,v:'normalState'},{id:854718,v:'normalState'},{id:854730,v:'normalState'},{id:854742,v:'normalState'},{id:854754,v:'normalState'},{id:854766,v:'normalState'},{id:854778,v:'normalState'},{id:854795,v:'normalState'},{id:854817,v:'normalState'},{id:854835,v:'normalState'},{id:854853,v:'normalState'},{id:854871,v:'normalState'},{id:854889,v:'normalState'},{id:854907,v:'normalState'},{id:854925,v:'normalState'},{id:854943,v:'normalState'},{id:854951,v:'normalState'},{id:854960,v:'normalState'},{id:861718,v:'normalState'},{id:861730,v:'normalState'},{id:861742,v:'normalState'},{id:861754,v:'normalState'},{id:861766,v:'normalState'},{id:861778,v:'normalState'},{id:861790,v:'normalState'},{id:861807,v:'normalState'},{id:861829,v:'normalState'},{id:861847,v:'normalState'},{id:861865,v:'normalState'},{id:861883,v:'normalState'},{id:861901,v:'normalState'},{id:861919,v:'normalState'},{id:861937,v:'normalState'},{id:861955,v:'normalState'},{id:861963,v:'normalState'},{id:861972,v:'normalState'},{id:867969,v:'normalState'},{id:868013,v:'normalState'},{id:809175,v:'normalState'},{id:809186,v:'normalState'},{id:809202,v:'normalState'},{id:809216,v:'normalState'},{id:872865,v:'normalState'},{id:872879,v:'normalState'},{id:872896,v:'normalState'},{id:872909,v:'normalState'},{id:872941,v:'normalState'},{id:872955,v:'normalState'},{id:872971,v:'normalState'},{id:872983,v:'normalState'},{id:876593,v:'normalState'},{id:876607,v:'normalState'},{id:876630,v:'normalState'},{id:876649,v:'normalState'},{id:877565,v:'normalState'},{id:877579,v:'normalState'},{id:877598,v:'normalState'},{id:877613,v:'normalState'},{id:687205,v:'normalState'},{id:317325,v:'normalState'},{id:765413,v:'normalState'},{id:765405,v:'normalState'},{id:762205,v:'normalState'},{id:763789,v:'normalState'},{id:880796,v:'normalState'},{id:762016,v:'normalState'},{id:762003,v:'normalState'},{id:761990,v:'normalState'},{id:761977,v:'normalState'},{id:880787,v:'normalState'},{id:687477,v:'normalState'},{id:318070,v:'normalState'},{id:810407,v:'normalState'},{id:810420,v:'normalState'},{id:810433,v:'normalState'},{id:810448,v:'normalState'},{id:810461,v:'normalState'},{id:810473,v:'normalState'},{id:811415,v:'normalState'},{id:811232,v:'normalState'},{id:811246,v:'normalState'},{id:811261,v:'normalState'},{id:811276,v:'normalState'},{id:907555,v:'normalState'},{id:908539,v:'normalState'},{id:910327,v:'normalState'},{id:912648,v:'normalState'},{id:810814,v:'normalState'},{id:810829,v:'normalState'},{id:810843,v:'normalState'},{id:810857,v:'normalState'},{id:810871,v:'normalState'},{id:810893,v:'normalState'},{id:810902,v:'normalState'},{id:810911,v:'normalState'},{id:810920,v:'normalState'},{id:810929,v:'normalState'},{id:688088,v:'normalState'},{id:319565,v:'normalState'},{id:70221,v:'normalState'},{id:322983,v:'normalState'},{id:322975,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:787509,v:'normalState'},{id:787523,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:321952,v:'normalState'},{id:321944,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:787566,v:'normalState'},{id:787580,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:923576,v:'normalState'},{id:923590,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
